{{ ---------------------------------------------------------------------------------------------------------

Hive-Computer-Projekt: Kommando "yload" - ymodem-download

xx-xx-2009      - erste Version von Julian


 --------------------------------------------------------------------------------------------------------- }}


OBJ
        ios     : "ios"
        ser     : "FullDuplexSerial256"       ' Full Duplex Serial Controller
        ymodem  : "ymodemlib"

CON

_CLKMODE     = XTAL1 + PLL16X
_XINFREQ     = 5_000_000
VAR
  byte modus
  
  BYTE BUFs[128]               ' Small buffer for 128byte packets
  BYTE BUFb[1024]              ' Big buffer for 1kbyte packets
PUB main
  ios.start
  ios.startram                                          ' code fr test im ram, sollte bei bin-datei auskommentiert werden 
  ios.print(@msg0)
  ios.printnl
  yload
  ios.stop

PUB checkfile | status
  status := ios.sdopen("r",@yfile)                   'test ob datei vorhanden
  ios.sdclose                                           'datei gleich wieder schlieen
  if status == 0                                        'datei ist schon vorhanden
    ios.print(@msg1)
    if ios.keywait <> "j"
      ios.print(string("nein"))
      ios.printnl
      return false
    else
      ios.print(string("ja"))
      ios.printnl
      return true
  else
    return true

PUB yload | CRC,header,packnr,oldpacknr,filename,filesize,mode,init,i,c,buffer
  mode := 0
  init := False

  ymodem.initserial
  
  REPEAT while init <> true
    if ios.key == "c"
      QUIT
    init := ymodem.initdownload
    
  if init == true
    ios.print(string("Ini succeded!"))
    ios.printnl
    packnr := ymodem.getpacknum
    oldpacknr := packnr
    'ios.printdec(packnr)
    repeat
      if packnr == 0
         buffer := ymodem.getpack128                                            'HIER LIEGT DER FEHLER (ODER IN DER LIB?)  
         filename := ymodem.getfilename(@BUFs)
         filesize := ymodem.getfilesize(@BUFs,strsize(filename) +2)
        ios.printnl
        ios.printhex(ymodem.calccrc(buffer),4)
         CRC := ymodem.getcrc
         ios.printhex(buffer,265)    
         'ios.print(filename)
         'ios.printnl
         'ios.printdec(filesize)
         ios.printnl
         ios.printhex(CRC,4)
         'ios.sdopen("w",string("ydebg.txt"))
         'bwrite(@BUFs)
         'ios.sdclose
      elseif oldpacknr > packnr
        'print error
        'cancle Transfer
      else
        'download
    
          

PUB bwrite(puffer) | n,i

repeat i from 0 to 127
  n := byte[puffer][i]
  ios.sdputc(n)

DAT

yfile         byte      "ydbg.txt",0
msg0          byte      13,"yLoad Devel JR",13,0
msg1          byte      "Zieldatei vorhanden! berschreiben? <j/n>: ", 0 


  